--
-- MAZ
--
-- M@D Author  KONDOR    
-- M@D date  30.07.14
--

MAZ = {}

function MAZ.prerequisitesPresent(specializations)
	Vehicle.registerJointType("frontloader");
    return true ;
end;

function MAZ:load(xmlFile)

local rotationPartNodepravDoor = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.pravDoor#index"));
    if rotationPartNodepravDoor ~= nil then
        self.rotationPartpravDoor = {};
        self.rotationPartpravDoor.node = rotationPartNodepravDoor;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartpravDoor#minRot"));
        self.rotationPartpravDoor.minRot = {};
        self.rotationPartpravDoor.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartpravDoor.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartpravDoor.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.pravDoor#maxRot"));
        self.rotationPartpravDoor.maxRot = {};
        self.rotationPartpravDoor.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartpravDoor.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartpravDoor.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartpravDoor.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.pravDoor#rotTime"), 2)*1000;
        self.rotationPartpravDoor.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.pravDoor#touchRotLimit"), 10));
    end;

   local rotationPartNodelevDoor = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.levDoor#index"));
    if rotationPartNodelevDoor ~= nil then
        self.rotationPartlevDoor = {};
        self.rotationPartlevDoor.node = rotationPartNodelevDoor;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartlevDoor#minRot"));
        self.rotationPartlevDoor.minRot = {};
        self.rotationPartlevDoor.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartlevDoor.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartlevDoor.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.levDoor#maxRot"));
        self.rotationPartlevDoor.maxRot = {};
        self.rotationPartlevDoor.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartlevDoor.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartlevDoor.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartlevDoor.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.levDoor#rotTime"), 2)*1000;
        self.rotationPartlevDoor.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.levDoor#touchRotLimit"), 10));
    end;

	local rotationPartNodeTanknadel = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.benzin#index"));
    if rotationPartNodeTanknadel ~= nil then
        self.benzin = {};
        self.benzin.node = rotationPartNodeTanknadel;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.benzin#minRot"));
        self.benzin.minRot = {};
        self.benzin.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.benzin.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.benzin.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.benzin#maxRot"));
        self.benzin.maxRot = {};
        self.benzin.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.benzin.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.benzin.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.benzin.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.benzin#rotTime"), 2)*1000;
        self.benzin.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.benzin#touchRotLimit"), 10));
    end;

    local rotationPartNodeDrehzahl1 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.tahometr1#index"));
    if rotationPartNodeDrehzahl1 ~= nil then
        self.tahometr1 = {};
        self.tahometr1.node = rotationPartNodeDrehzahl1;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.tahometr1#minRot"));
        self.tahometr1.minRot = {};
        self.tahometr1.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.tahometr1.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.tahometr1.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.tahometr1#maxRot"));
        self.tahometr1.maxRot = {};
        self.tahometr1.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.tahometr1.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.tahometr1.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.tahometr1.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.tahometr1#rotTime"), 2)*1000;
        self.tahometr1.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.tahometr1#touchRotLimit"), 10));
    end;
	
	local rotationPartNodestrelka4 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.strelka4#index"));

    if rotationPartNodestrelka4 ~= nil then
        self.rotationPartstrelka4 = {};
        self.rotationPartstrelka4.node = rotationPartNodestrelka4;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.strelka4#minRot"));
        self.rotationPartstrelka4.minRot = {};
        self.rotationPartstrelka4.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartstrelka4.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartstrelka4.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.strelka4#maxRot"));
        self.rotationPartstrelka4.maxRot = {};
        self.rotationPartstrelka4.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartstrelka4.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartstrelka4.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartstrelka4.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.strelka4#rotTime"), 2)*1000;
        self.rotationPartstrelka4.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.strelka4#touchRotLimit"), 10));
    end;

local rotationPartNodestrelka3 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.strelka3#index"));

    if rotationPartNodestrelka3 ~= nil then
        self.rotationPartstrelka3 = {};
        self.rotationPartstrelka3.node = rotationPartNodestrelka3;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.strelka3#minRot"));
        self.rotationPartstrelka3.minRot = {};
        self.rotationPartstrelka3.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartstrelka3.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartstrelka3.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.strelka3#maxRot"));
        self.rotationPartstrelka3.maxRot = {};
        self.rotationPartstrelka3.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartstrelka3.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartstrelka3.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartstrelka3.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.strelka3#rotTime"), 2)*1000;
        self.rotationPartstrelka3.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.strelka3#touchRotLimit"), 10));
    end;


local rotationPartNodestrelka2 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.strelka2#index"));

    if rotationPartNodestrelka2 ~= nil then
        self.rotationPartstrelka2 = {};
        self.rotationPartstrelka2.node = rotationPartNodestrelka2;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.strelka2#minRot"));
        self.rotationPartstrelka2.minRot = {};
        self.rotationPartstrelka2.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartstrelka2.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartstrelka2.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.strelka2#maxRot"));
        self.rotationPartstrelka2.maxRot = {};
        self.rotationPartstrelka2.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartstrelka2.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartstrelka2.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartstrelka2.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.strelka2#rotTime"), 2)*1000;
        self.rotationPartstrelka2.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.strelka2#touchRotLimit"), 10));
    end;


local rotationPartNodestrelka1 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.strelka1#index"));

    if rotationPartNodestrelka1 ~= nil then
        self.rotationPartstrelka1 = {};
        self.rotationPartstrelka1.node = rotationPartNodestrelka1;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.strelka1#minRot"));
        self.rotationPartstrelka1.minRot = {};
        self.rotationPartstrelka1.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartstrelka1.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartstrelka1.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.strelka1#maxRot"));
        self.rotationPartstrelka1.maxRot = {};
        self.rotationPartstrelka1.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartstrelka1.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartstrelka1.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartstrelka1.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.strelka1#rotTime"), 2)*1000;
        self.rotationPartstrelka1.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.strelka1#touchRotLimit"), 10));
    end;
	
end;
      
function MAZ:delete()      
end;

function MAZ:mouseEvent(posX, posY, isDown, isUp, button)
end;
	  
function MAZ:keyEvent(unicode, sym, modifier, isDown)
end;

function MAZ:update(dt)

    if self.isMotorStarted then
		if self.benzin ~= nil then
			local x, y, z = getRotation(self.benzin.node);
			y = ((self.benzin.maxRot[2] - self.benzin.minRot[2]) / self.fuelCapacity) * self.fuelFillLevel + self.benzin.minRot[2];
			setRotation(self.benzin.node, x, y ,z);
		end;
	else
			setRotation(self.benzin.node, 0, 0 ,0);
	end;

	if self.isMotorStarted then
			local maxDrehzahl = 1200;
			if self.tahometr1 ~= nil then
				local x, y, z = getRotation(self.tahometr1.node);
				y = ((self.tahometr1.maxRot[2] - self.tahometr1.minRot[2]) / maxDrehzahl) * self.motor.lastMotorRpm + self.tahometr1.minRot[2];
				setRotation(self.tahometr1.node, x, y ,z);
			end;
	else
			setRotation(self.tahometr1.node, 0, 0 ,0);
	end;
		
	if self.isEntered then
		if self.isMotorStarted then
			self.rotationMaxstrelka1 = true;
			self.rotationMaxstrelka2 = true;
			self.rotationMaxstrelka3 = true;
			self.rotationMaxstrelka4 = true;
		else			
			self.rotationMaxstrelka1 = false;
			self.rotationMaxstrelka2 = false;
			self.rotationMaxstrelka3 = false;
			self.rotationMaxstrelka4 = false;
		end;
	end;

	if self.rotationPartstrelka1 ~= nil then
		local x, y, z = getRotation(self.rotationPartstrelka1.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartstrelka1.maxRot, self.rotationPartstrelka1.minRot, 3, self.rotationPartstrelka1.rotTime, dt, not self.rotationMaxstrelka1);
		setRotation(self.rotationPartstrelka1.node, unpack(newRot));
	end;

	if self.rotationPartstrelka2 ~= nil then
		local x, y, z = getRotation(self.rotationPartstrelka2.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartstrelka2.maxRot, self.rotationPartstrelka2.minRot, 3, self.rotationPartstrelka2.rotTime, dt, not self.rotationMaxstrelka2);
		setRotation(self.rotationPartstrelka2.node, unpack(newRot));
	end;

	if self.rotationPartstrelka3 ~= nil then
		local x, y, z = getRotation(self.rotationPartstrelka3.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartstrelka3.maxRot, self.rotationPartstrelka3.minRot, 3, self.rotationPartstrelka3.rotTime, dt, not self.rotationMaxstrelka3);
		setRotation(self.rotationPartstrelka3.node, unpack(newRot));
	end;

	if self.rotationPartstrelka4 ~= nil then
		local x, y, z = getRotation(self.rotationPartstrelka4.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartstrelka4.maxRot, self.rotationPartstrelka4.minRot, 3, self.rotationPartstrelka4.rotTime, dt, not self.rotationMaxstrelka4);
		setRotation(self.rotationPartstrelka4.node, unpack(newRot));
	end;
	
 if self.inrange or self.isEntered then
	if InputBinding.hasEvent (InputBinding.levDoor_MAZ) then
		self.rotationMaxlevDoor = not self.rotationMaxlevDoor;
	end;
	if InputBinding.hasEvent (InputBinding.pravDoor_MAZ) then
		self.rotationMaxpravDoor = not self.rotationMaxpravDoor;
	end;
end;

	if self.inrange or self.isEntered then
		if self.rotationMaxlevDoor then
			g_currentMission:addHelpButtonText(g_i18n:getText("levDoor_MAZ_n1"), InputBinding.levDoor_MAZ);
		else
			g_currentMission:addHelpButtonText(g_i18n:getText("levDoor_MAZ_n2"), InputBinding.levDoor_MAZ);
		end;

		if self.rotationMaxpravDoor then
			g_currentMission:addHelpButtonText(g_i18n:getText("pravDoor_MAZ_n1"), InputBinding.pravDoor_MAZ);
		else
			g_currentMission:addHelpButtonText(g_i18n:getText("pravDoor_MAZ_n2"), InputBinding.pravDoor_MAZ);
		end;
	end;	

        if self.rotationPartpravDoor ~= nil then
		   local x, y, z = getRotation(self.rotationPartpravDoor.node);
		   local rot = {x,y,z};
		   local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartpravDoor.maxRot, self.rotationPartpravDoor.minRot, 3, self.rotationPartpravDoor.rotTime, dt, not self.rotationMaxpravDoor);
		   setRotation(self.rotationPartpravDoor.node, unpack(newRot));
        end;

	    if self.rotationPartlevDoor ~= nil then
		   local x, y, z = getRotation(self.rotationPartlevDoor.node);
		   local rot = {x,y,z};
		   local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartlevDoor.maxRot, self.rotationPartlevDoor.minRot, 3, self.rotationPartlevDoor.rotTime, dt, not self.rotationMaxlevDoor);
		   setRotation(self.rotationPartlevDoor.node, unpack(newRot));
        end;
end;
	
function MAZ:draw()
end;

function MAZ:updateTick(dt)
if g_currentMission.player ~= nil then
		-- Getting the distance between the player and the implement 
		local nearestDistance = 6.0; --max distance allowed
		local px, py, pz = getWorldTranslation(self.rootNode); 
			self.inrange = true; 
		local vx, vy, vz = getWorldTranslation(g_currentMission.player.rootNode);
		local distance = Utils.vector3Length(px-vx, py-vy, pz-vz);	
		if distance < nearestDistance then
		else
			self.inrange = false; 
		end;
	end;		
end;

function MAZ:validateAttacherJoint(implement, jointDesc, dt)
    return true;
end;
